#!/usr/bin/perl

###############################################################################
#                                                                             #
# Filename: ncu_httpa.pl                                                      #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

###############################################################################
# GetAddressHash
###############################################################################

sub GetAddressHash
{
	my %AddressHash;
	my @KeyValueSets = split(/,/, shift);
	my $KeyValueSet;
	my $Value;
	my $Key;

	# Set up the hash...
	foreach $KeyValueSet (@KeyValueSets)
	{
		# Break apart the set.
		($Key, $Value) = split(/:/, $KeyValueSet);

		# Set the key/value pair into the hash.
		$AddressHash{$Key} = $Value;
	}

	return %AddressHash;
}

###############################################################################
# Main
###############################################################################

sub Main
{
	my %AddressHashNew;
	my $i;
	my $Return			= 0;
    
	# Run through the arguments...
	for $i (0 .. $#ARGV)
	{
		# Try to get the new NIC address list...
		if ($ARGV[$i] eq '-nnac')
		{
			# Parse out the data.
			%AddressHashNew = GetAddressHash($ARGV[$i + 1]);

			last;
		}
	}

	# If all of the information is available...
	if (defined(%AddressHashNew))
	{
		my $AddressNew	= (($AddressHashNew{'eth0'}) && ('0.0.0.0' ne $AddressHashNew{'eth0'})) ? $AddressHashNew{'eth0'} : $AddressHashNew{'eth1'};

		# If there is a new address to assign...
		if (($AddressNew) &&
			('0.0.0.0' ne $AddressNew))
		{
			# Try to open the httpd configuration file...
			if (open(HTTPDA, "< /usr/ins/intel/apache/conf/httpd.conf"))
			{
				my @Configuration	= <HTTPDA>;
				my $Line;
				my $Key;

				# Close the file.
				close(HTTPDA);

				# Run through the configuraiton file...
				foreach $Line (@Configuration)
				{
					# Try to find the entry...
					if ($Line =~ /RewriteCond\s+?%\{HTTP_HOST}\s+?!\^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/)
					{
						# Update the SSL configuration.
						$Line = "RewriteCond %{HTTP_HOST}             !^$AddressNew(:5555)\n";
					}
				}

				# To to open the file to write to it...
				if (open(HTTPDA, "> /usr/ins/intel/apache/conf/httpd.conf"))
				{
					# Rewrite the configuration.
					print HTTPDA @Configuration;

					# Close the file.
					close(HTTPDA);

					# Restart the service.
					`/etc/rc.d/init.d/httpd-admin restart`;
				}
			}
		}
	}

	return $Return;
}

###############################################################################
# main body
###############################################################################

exit(Main());

