#!/usr/bin/perl

###############################################################################
#                                                                             #
# Filename: raidcleanup.pl                                                    #
#                                                                             #
# Description: Script to finish the job started by raidmirror.pl.             #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

use strict;

undef $/;
open (LOGFILE, ">>/var/log/raid1convert.log") || warn "Unable to open logfile\n";
print LOGFILE "009, Beginning cleanup script\n";
if (!open(RCLOCAL, "/etc/rc.d/rc.local")) {
   print LOGFILE "Error: unable to remove self from rc.local!";
   die "Unable to remove self!\n";
   }
my $rclocal = <RCLOCAL>;
close(RCLOCAL);
$rclocal =~ s/\n.*raidcleanup.pl\n//;
if (!open(RCLOCAL, ">/etc/rc.d/rc.local")) {
   print LOGFILE "Error: unable to remove self from rc.local!";
   die "Unable to remove self!\n";
   }
print RCLOCAL $rclocal;
# The origional device will be still be mounted on /boot
# findpartition depends upon $/ being defined
$/ = "\n";
my $srcdev = findpartition("/boot");
undef $/;
chop($srcdev);
print LOGFILE "010, Marking drives as working\n";
open(RAIDTAB, "/etc/raidtab");
my $raidtab = <RAIDTAB>;
close(RAIDTAB);
$raidtab =~ s/failed-disk/raid-disk/g;
open(RAIDTAB, ">/etc/raidtab");
print RAIDTAB $raidtab;
close(RAIDTAB);
print LOGFILE "011, Adding devices to active raid\n";
# find all of the /dev/hdaX partitions and put them into the array
my @partlist = $raidtab=~/($srcdev.)/g;
# get the same list of the /dev/mdX devices
my @raidlist = $raidtab=~/(\/dev\/md.)/g;
my $i = 0;
foreach $_ (@partlist) {
   `/sbin/raidhotadd $raidlist[$i] $_`;
   $i++;
}
print LOGFILE "012, RAID conversion complete.  Reconstruction should be progressing\n";

$/ = "\n";

exit(0);

sub findpartition {
   my ($mpoint) = @_;
   my $found;
   open (FSTAB, "/etc/fstab") || die "unable to open /etc/fstab for reading";
   my @fstab = <FSTAB>;
   close (FSTAB);
   foreach $_ (@fstab) {
      if (/$mpoint\s/) {
         ($found) = /(\S*)/ ;
      }
   }
   if (!$found) {
      return "Failure to find $mpoint\n";
   }
   return $found;

}



